
import json
import argparse
from flask import Flask,render_template,request, Response, json


app = Flask(__name__, template_folder='./')

def json_safe(string, content_type='application/octet-stream'):
    """Returns JSON-safe version of `string`.

    If `string` is a Unicode string or a valid UTF-8, it is returned unmodified,
    as it can safely be encoded to JSON string.

    If `string` contains raw/binary data, it is Base64-encoded, formatted and
    returned according to "data" URL scheme (RFC2397). Since JSON is not
    suitable for binary data, some additional encoding was necessary; "data"
    URL scheme was chosen for its simplicity.
    """
    try:
        string = string.decode('utf-8')
        json.dumps(string)
        return string
    except (ValueError, TypeError):
        return b''.join([
            b'data:',
            content_type.encode('utf-8'),
            b';base64,',
            base64.b64encode(string)
        ]).decode('utf-8')

    
@app.route('/show',methods=['GET','POST'])
def show():
    data = 'default'
    with open('./data.txt', encoding='utf8') as f:
        lines = f.readlines()
        if len(lines)>0:
            data = lines[-1]
    return render_template('test.html', data=data)

@app.route('/mock',methods=['GET','POST'])
def modify():
    data = ''
    if request.method=='POST':
        #data=request.form.get('data')
        data=json_safe(request.data)
        print(data)

    if request.method=='GET':
        data=request.args.get('data')
    
    if data:
        with open('data.txt','a', encoding='utf-8') as f:
            f.write('\n') 
            f.write(data)
            
    return Response(json.dumps({'code':200}))


if __name__ == '__main__':
    app.run(host='0.0.0.0',port=5000)
